﻿param ( 
           [string] $filename,
           [string] $inputFolder=(Get-Item -Path '.\' -Verbose).FullName,
           [boolean] $IgnoreSystemAccounts = $true,
           [boolean] $Confirmation=$false
      )



Set-StrictMode -Version 2
Import-Module ActiveDirectory
# Set the working directory to the script's directory
Push-Location (Split-Path ($MyInvocation.MyCommand.Path))



Function ShowMsg
{
    Param($mesg)
    echo $mesg
}


Function ForcePasswordChange($ADUser)
{

            if ($IgnoreSystemAccounts -eq $true)
            {
                if ($AdUser.SamAccountName.Contains("$") -or $AdUser.SamAccountName.Contains("SM_"))
                {
                    #Do nothing 
                }
                else
                {
                
                    ShowMsg("Forcing password change at next logon for user " + $ADUser.SamAccountName)
                    Set-AdUser -Identity $ADUser.SamAccountName -ChangePasswordAtLogon:$true -PasswordNeverExpires:$false -Confirm:$Confirmation
                }
            }
            else
            {
                
                ShowMsg("Forcing password change at next logon for user2 " + $ADUser.SamAccountName)
                Set-AdUser -Identity $ADUser.SamAccountName -ChangePasswordAtLogon:$true -PasswordNeverExpires:$false -Confirm:$Confirmation
            }
}

####### Start of Main 
Clear-Host
try
{
    ShowMsg "Starting parse "
    $fullfilename=$inputFolder+"\"+$filename

    ShowMsg ("Full file name = " + $fullfilename)

    $fileExists = Test-Path $fullfilename 
} catch
{
    $fileExists=$false 
}



if ( $fileExists -eq $false)
{
    ShowMsg "File not found."
}
else
{
    ShowMsg "File found at location " + $filename 
    $file = Import-csv $fullfilename 
    $users =[System.Collections.ArrayList]@()

    foreach ($line in $file)
    {
        try
        {
           $users.Add($line.user)

        }catch
        {

        }

        try
        {
           foreach($user in $line.users -split " ")
           {                     
                
                if ($user -ne ""){  $users.Add($user) }
           }
        }
        catch
        {

        }
    }

    # At this stage we go through all the users accounts

    foreach($user in $users)
    {
        try
        {
            $ADUser = Get-ADUser $user
            if ($ADUser -ne $Null)
            {
                
                ForcePasswordChange($ADUser)
            }
        }catch
        {

        }
    }
}







